stages:
- build
- deploy

variables:
  GIT_SUBMODULE_STRATEGY: recursive

build:
  stage: build
  when: on_success
  only:
    - production
  image: docker:stable
  services:
    - docker:dind
  script:
    - docker login -u gitlab-ci-token -p $CI_JOB_TOKEN $CI_REGISTRY
    - docker build -t $CI_REGISTRY_IMAGE:production -t $CI_REGISTRY_IMAGE:$CI_COMMIT_SHORT_SHA .
    - docker push $CI_REGISTRY_IMAGE:production
    - docker push $CI_REGISTRY_IMAGE:$CI_COMMIT_SHORT_SHA

build_staging:
  stage: build
  when: on_success
  only:
    - staging
  image: docker:stable
  services:
    - docker:dind
  script:
    - docker login -u gitlab-ci-token -p $CI_JOB_TOKEN $CI_REGISTRY
    - docker build -t $CI_REGISTRY_IMAGE:staging -t $CI_REGISTRY_IMAGE:$CI_COMMIT_SHORT_SHA .
    - docker push $CI_REGISTRY_IMAGE:staging
    - docker push $CI_REGISTRY_IMAGE:$CI_COMMIT_SHORT_SHA

deploy_staging:
  stage: deploy
  when: on_success
  only:
    - staging
  image: registry.gitlab.com/crowdsoft-foundation/various/pytestkube:latest

  script:
    - find ./. -type f \( -name '*_staging.yaml' \) -print0 | xargs -0 sed -i "s#\[image\]#$CI_REGISTRY_IMAGE:$CI_COMMIT_SHORT_SHA#g"
    - kubectl apply -f ./cron_staging.yaml --kubeconfig="$KUBECONFIG_STAGING"

deploy_live:
  stage: deploy
  when: on_success
  only:
    - production
  image: registry.gitlab.com/crowdsoft-foundation/various/pytestkube:latest

  script:
    - find ./. -type f \( -name '*.yaml' \) -print0 | xargs -0 sed -i "s#\[image\]#$CI_REGISTRY_IMAGE:$CI_COMMIT_SHORT_SHA#g"
    - kubectl apply -f ./cron.yaml --kubeconfig="$KUBECONFIG_LIVE"
